package com.vendor.loader.model;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.struct.FileSystem;
import com.vendor.loader.struct.FlashType;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.xml.sax.SAXException;

public class PartitionItem {
  public static final String PART = "Part";
  
  private static final String att_Sel = "Sel";
  
  private static final String att_PartitionName = "PartitionName";
  
  private static final String att_PartitionVersione = "PartitionVersion";
  
  private static final String att_PartitionVersionTag = "PartitionVersionTag";
  
  private static final String att_FlashType = "FlashType";
  
  private static final String att_FileSystem = "FileSystem";
  
  private static final String att_Start = "Start";
  
  private static final String att_Length = "Length";
  
  private static final String att_SelectFile = "SelectFile";
  
  private static final String BLANK = " ";
  
  private static final String VALUE_START = "=\"";
  
  private static final String VALUE_END = "\"";
  
  private boolean checked;
  
  private String partitionName;
  
  private int PartitionVersione;
  
  private int PartitionVersionTag;
  
  private FlashType flashType = FlashType.nand;
  
  private FileSystem fileSystem = FileSystem.none;
  
  private long start;
  
  private long length;
  
  private File file;
  
  public File getFile() {
    return this.file;
  }
  
  public FileSystem getFileSystem() {
    return this.fileSystem;
  }
  
  public FlashType getFlashType() {
    return this.flashType;
  }
  
  public long getLength() {
    return this.length;
  }
  
  public String getName() {
    return this.partitionName;
  }
  
  public long getStart() {
    return this.start;
  }
  
  public void setFile(File file) {
    this.file = file;
  }
  
  public void setFileSystem(FileSystem fileSystem) {
    this.fileSystem = fileSystem;
  }
  
  public void setFlashType(FlashType flashType) {
    this.flashType = flashType;
  }
  
  public void setLength(long length) {
    this.length = length;
  }
  
  public void setName(String name) {
    this.partitionName = name;
  }
  
  public void setStart(long start) {
    this.start = start;
  }
  
  public boolean isChecked() {
    return this.checked;
  }
  
  public void setChecked(boolean checked) {
    this.checked = checked;
  }
  
  public int getPartitionVersione() {
    return this.PartitionVersione;
  }
  
  public void setPartitionVersione(int partitionVersione) {
    this.PartitionVersione = partitionVersione;
  }
  
  public int getPartitionVersionTag() {
    return this.PartitionVersionTag;
  }
  
  public void setPartitionVersionTag(int partitionVersionTag) {
    this.PartitionVersionTag = partitionVersionTag;
  }
  
  public static List<com.vendor.loader.model.PartitionItem> load(File file, boolean xmlPathDefault) throws DocumentException {
    List<com.vendor.loader.model.PartitionItem> results = new ArrayList<>();
    if (!file.exists() || !file.isFile())
      return results; 
    SAXReader reader = new SAXReader();
    try {
      reader.setFeature("http://apache.org/xml/features/disallow-doctype-decl", true);
    } catch (SAXException e) {
      return results;
    } 
    Document document = reader.read(file);
    Element root = document.getRootElement();
    File home = new File(file.getParent());
    for (Iterator<?> parent = root.elementIterator("Part"); parent.hasNext(); ) {
      Element part = (Element)parent.next();
      com.vendor.loader.model.PartitionItem partitionItem = convert(part, home, xmlPathDefault);
      if (partitionItem == null)
        continue; 
      results.add(partitionItem);
    } 
    return results;
  }
  
  public final String toString() {
    StringBuilder sb = new StringBuilder();
    try {
      sb.append("<Part")
        .append(" ")
        .append("Sel")
        .append("=\"")
        .append(isChecked() ? "1" : "0")
        .append("\"")
        .append(" ")
        .append("PartitionName")
        .append("=\"")
        .append((getName() == null) ? "" : getName())
        .append("\"")
        .append(" ")
        .append("PartitionVersion")
        .append("=\"")
        .append("" + getPartitionVersione())
        .append("\"")
        .append(" ")
        .append("PartitionVersionTag")
        .append("=\"")
        .append("" + getPartitionVersionTag())
        .append("\"")
        .append(" ")
        .append("FlashType")
        .append("=\"")
        .append((getFlashType() == null) ? "" : getFlashType().name())
        .append("\"")
        .append(" ")
        .append("FileSystem")
        .append("=\"")
        .append((getFileSystem() == null) ? "" : getFileSystem().name())
        .append("\"").append(" ").append("Start")
        .append("=\"").append(convertUnit(getStart()))
        .append("\"").append(" ").append("Length")
        .append("=\"")
        .append((getLength() == -1L) ? "-" : convertUnit(getLength()))
        .append("\"").append(" ").append("SelectFile")
        .append("=\"")
        .append((getFile() == null) ? "" : getFile().getCanonicalPath())
        .append("\"").append("/>\n");
    } catch (IOException e) {
      return sb.toString();
    } 
    return sb.toString();
  }
  
  public static String convertUnit(long num) {
    String unit = "";
    if (num == 0L)
      return "0"; 
    if (num % 1024L != 0L)
      return "" + num; 
    unit = "K";
    num /= 1024L;
    if (num < 1024L)
      return "" + num + num; 
    if (num % 1024L != 0L)
      return "" + num + num; 
    unit = "M";
    num /= 1024L;
    return "" + num + num;
  }
  
  public static com.vendor.loader.model.PartitionItem convert(Element part, File home, boolean xmlPathDefault) {
    if (part == null || !part.getName().equals("Part"))
      return null; 
    String sel = part.attributeValue("Sel");
    if (sel == null)
      return null; 
    int parseInt = Integer.parseInt(sel);
    if (parseInt != 0 && parseInt != 1)
      return null; 
    com.vendor.loader.model.PartitionItem item = new com.vendor.loader.model.PartitionItem();
    item.setChecked((parseInt == 1));
    String partitionName = part.attributeValue("PartitionName");
    if (partitionName != null)
      item.setName(partitionName.toLowerCase()); 
    String PartitionVersion = part.attributeValue("PartitionVersion");
    if (PartitionVersion != null)
      item.setPartitionVersione((int)convertToNumber(PartitionVersion)); 
    String PartitionVersionTag = part.attributeValue("PartitionVersionTag");
    if (PartitionVersionTag != null)
      item.setPartitionVersionTag((int)convertToNumber(PartitionVersionTag)); 
    String strFlashType = part.attributeValue("FlashType");
    FlashType flashType = FlashType.valueOf(strFlashType.toLowerCase());
    item.setFlashType(flashType);
    String strFileSystem = part.attributeValue("FileSystem");
    FileSystem fileSystem = FileSystem.valueOf(strFileSystem.toLowerCase());
    item.setFileSystem(fileSystem);
    String strStart = part.attributeValue("Start");
    long convert = convertToNumber(strStart);
    item.setStart(convert);
    String strLength = part.attributeValue("Length");
    if (!strLength.equals("-")) {
      long length = convertToNumber(strLength);
      item.setLength(length);
    } else {
      item.setLength(-1L);
    } 
    String strSelectFile = part.attributeValue("SelectFile");
    int lastIndexOf = strSelectFile.lastIndexOf("\\");
    if (lastIndexOf == -1)
      lastIndexOf = strSelectFile.lastIndexOf("/"); 
    String newPath = null;
    File newFile = null;
    String homeFileName = "";
    try {
      homeFileName = home.getCanonicalPath();
    } catch (IOException e) {
      return null;
    } 
    if (lastIndexOf != -1 || strSelectFile.trim().length() == 0) {
      if (strSelectFile.startsWith("./")) {
        strSelectFile = homeFileName + "/" + homeFileName;
        newPath = strSelectFile;
        newFile = new File(newPath);
      } else {
        newPath = strSelectFile;
        if (xmlPathDefault) {
          strSelectFile = strSelectFile.substring(lastIndexOf + 1);
          newPath = homeFileName + "/" + homeFileName;
          newFile = new File(newPath);
        } else {
          newFile = new File(strSelectFile);
        } 
      } 
    } else {
      newPath = homeFileName + "/" + homeFileName;
      newFile = new File(newPath);
    } 
    boolean isSelect = (newFile != null && (!newFile.exists() || strSelectFile.length() == 0));
    if (isSelect)
      newFile = null; 
    item.setFile(newFile);
    return item;
  }
  
  public static long convertToNumber(String strNum) {
    if (strNum == null || strNum.trim().length() == 0)
      return -1L; 
    strNum = strNum.toLowerCase();
    long unit = 1L;
    int index = strNum.length();
    if ((index = strNum.indexOf("g")) != -1) {
      unit = 1073741824L;
    } else if ((index = strNum.indexOf("k")) != -1) {
      unit = 1024L;
    } else if ((index = strNum.indexOf("m")) != -1) {
      unit = 1048576L;
    } else if ((index = strNum.indexOf("b")) != -1) {
      unit = 1L;
    } else {
      index = strNum.length();
    } 
    try {
      return Long.parseLong(strNum.substring(0, index)) * unit;
    } catch (NumberFormatException e) {
      return -1L;
    } 
  }
  
  public static void save(File tableFile, List<com.vendor.loader.model.PartitionItem> children) {
    OutputStream out = null;
    try {
      out = new FileOutputStream(tableFile);
      out.write("<?xml version=\"1.0\" encoding=\"GB2312\" ?>\n".getBytes("GB2312"));
      out.write("<Partition_Info>\n".getBytes("GB2312"));
      for (com.vendor.loader.model.PartitionItem item : children)
        out.write(item.toString().getBytes("GB2312")); 
      out.write("</Partition_Info>\n".getBytes("GB2312"));
    } catch (FileNotFoundException fileNotFoundException) {
    
    } catch (IOException iOException) {
    
    } finally {
      if (out != null)
        try {
          out.close();
        } catch (IOException iOException) {} 
    } 
  }
}
